/* extended for V2 */


#ifndef GRAPHICS_GFXBASE_H
#include <graphics/gfxbase.h>
#endif

#ifndef INTUITION_INTUITIONBASE_H
#include <intuition/intuitionbase.h>
#endif

#define GIOF_LOADER8			1
#define GIOF_LOADER24		2
#define GIOF_SAVER8			4
#define GIOF_SAVER24			8
#define GIOF_LOADFILE		16
#define GIOF_SAVEFILE		32
#define GIOF_PLANAR			64			// data is loaded in planar format
#define GIOF_NOID				128		// not able to identify file
												// (skip in universial loader search)
#define GIOF_NOFILEOPEN		256		// do file access internally
												// (giodata->Data and
												// giodata->Filehandle are not set up)

// 512 - obsolete

#define GIOF_LOADNOPROGRESS	1024
#define GIOF_SAVENOPROGRESS	2048
#define GIOF_EXTENDED		4096		// extended features available
#define GIOF_SAVEPREFS		8192		// has prefs for loading
#define GIOF_LOADPREFS		16384		// has prefs for saving

// 32768 - obsolete

#define GIOF_AREXX			65536		// gio supports Arexx command parsing
#define GIOF_LOADTRANS		131072	// loads transparency (paintlayer)
#define GIOF_SAVETRANS		262144	// saves transparency (paintlayer)

struct GIOData
{
	struct	GIOData *Next;
	struct	GIOData *Prev;
	char	*	Filename;
	UBYTE		Data[64];
	BPTR		Filehandle;
	ULONG		Width;
	ULONG		Height;
	ULONG		Depth;
	ULONG    prv1;
	ULONG		prv2;
	ULONG		prv3;
	ULONG		prv4;
	ULONG		VP_mode;
	UWORD		Aspect_x;
	UWORD		Aspect_y;
	struct 	BitMap *Bitmap;
	LONG 		prv5;
   LONG		prv6;
	UBYTE	*	Palette;
	ULONG		Flags;
	ULONG		Headerlength;
	ULONG		Error;
	ULONG		UserData;
	ULONG		UserData2;
	ULONG		UserData3;
	struct	Library *PgsBase;
	ULONG		SkipBytes;
	struct	Library *DOSBase;
	struct	GfxBase *GfxBase;
	struct	IntuitionBase *IntuitionBase;
	struct	Library *UtilityBase;
	struct	Library *GadToolsBase;
	struct	Library *AslBase;
	struct	Library *ColorwheelBase;
	ULONG		extendedid;
	struct	Screen  *PgsScreen;
   LONG		prv7;
   LONG		prv8;
   LONG		prv9;
	UWORD		WindX;
	UWORD		WindY;
	UWORD		WindWidth;
	UWORD		WindHeight;
	UWORD		DestWidth;
	UWORD		DestHeight;
	UWORD		SecondWidth;
	UWORD		SecondHeight;
	UWORD		AlphaWidth;
	UWORD		AlphaHeight;
	UWORD		DestDepth;
	UWORD		SecondDepth;
	UWORD		AlphaDepth;
	UBYTE	*	DestPalette;
	UBYTE	*	SecondPalette;
	UBYTE	*	AlphaPalette;
	struct	Library *PgsrexxBase;
	char *	ArexxString;
	ULONG 	Language;
	LONG		prv10;
	struct	TagList *Extensions;			// for specific extensions to gios.
	ULONG 	ArexxError;
	UBYTE		Red;								// current R for selected colour
	UBYTE		Green;							// current G for selected colour
	UBYTE		Blue;								// current B for selected colour
	UBYTE		pad0;								// pad value
   LONG		prv11;
   LONG 		prv12;
   LONG		prv13;
   LONG		prv14;
	ULONG 	Channels;						// channels for buffer (efx use)
	UBYTE*	PreviewData;
	UWORD		PreviewWidth;
	UWORD		PreviewHeight;
	struct 	Library	*cyberbase;			// erk!
   ULONG		rendermode;
	ULONG		autosave;
   LONG		prv15;
   LONG		prv16;
	LONG		prv17;
   LONG		prv18;
};

// for giodata->Language field.. Check this field to see what language you
// should use in your requesters.

#define	LANG_ENGLISH	0
#define	LANG_GERMAN		1
#define	LANG_FRENCH		2
#define	LANG_ITALIAN	3
#define	LANG_SPANISH	4
#define	LANG_DUTCH		5
#define	LANG_POLISH		6
#define	LANG_PORTUGESE	7
#define	LANG_AMERICAN	8
#define	LANG_NORWEGIAN	9
#define	LANG_SWEDISH	10
#define	LANG_DANISH		11
#define	LANG_FINNISH	12
#define 	LANG_SCOTCH		13
#define  LANG_MANDARIN  14
#define  LANG_THP			15
#define  LANG_LATIN     16
#define  LANG_ESPERANTO 17
#define	LANG_ARABIC		18

// error msgs for gios & efx.

#define GIO_OK					0
#define GIO_RAMERR			1
#define GIO_FILEERR			2
#define GIO_WRONGTYPE		3
#define GIO_SYSERR			4
#define GIO_ABORTED			5
#define GIO_UNAVAILABLE		6
#define GIO_AREXXERROR		7

// flags to OR with y value in GetSrcLine, etc...

#define PGVM_READONLY 0x01000000
#define PGVM_WRITEONLY 0x02000000
#define PGVM_NOCACHE 0x04000000

#define	PCLONG	ULONG
#define	PCWORD	UWORD

// Doubt you'll need these. Not even sure if we still do!

#define PGTAG_LISTMIN 0x81910050
#define PGTAG_LISTMAX 0x81910060
#define PGTAG_ENTRY 0x81900a0
#define PGTAG_ENTRYID 0x81900b0
#define PGTAG_ENTRYTEXT 0x81900c0
#define PGTAG_ENTRYEND 0x81900e0
#define PGTAG_END 0x8191ffff
